#include "HLight.h"

void HLight::initBase() {
	glLightf(_light, GL_CONSTANT_ATTENUATION, _constantAttenuation);
	glLightf(_light, GL_LINEAR_ATTENUATION, _linearAttenuation);
	glLightf(_light, GL_QUADRATIC_ATTENUATION, _quadraticAttenuation);
}

void HLight::activate() {
	glEnable(_light);
}

void HLight::deactivate() {
	glDisable(_light);
}
void HLight::setPosition(float x, float y, float z) {
	_position[0] = x;
	_position[1] = y;
	_position[2] = z;
	_position[3] = 1;

	//glLightfv(_light, GL_POSITION, _position);
}

void HLight::setPosition() {
	glLightfv(_light, GL_POSITION, _position);
}

void HLight::setAmbient(float r, float g, float b, float a) {
	_ambient[0] = r;
	_ambient[1] = g;
	_ambient[2] = b;
	_ambient[3] = a;

	glLightfv(_light, GL_AMBIENT, _ambient);
}

void HLight::setDiffuse(float r, float g, float b, float a) {
	_diffuse[0] = r;
	_diffuse[1] = g;
	_diffuse[2] = b;
	_diffuse[3] = a;

	glLightfv(_light, GL_DIFFUSE, _diffuse);
}

void HLight::setSpecular(float r, float g, float b, float a) {
	_specular[0] = r;
	_specular[1] = g;
	_specular[2] = b;
	_specular[3] = a;

	glLightfv(_light, GL_SPECULAR, _specular);
}
