#ifndef HLight_h
#define HLight_h

#include "../platform.h"

#define SPOT_LIGHT 0
#define POINT_LIGHT 1

class HLight {
public:
	const GLuint _light;
protected:
	void initBase();

public:
	HLight(GLuint light) : _light(light) { }
	virtual void init() = 0;
	virtual int getType() = 0;
	void activate();
	void deactivate();

	void setPosition(float x, float y, float z);
	void setPosition();

	void setAmbient(float r, float g, float b, float a);
	void setDiffuse(float r, float g, float b, float a);
	void setSpecular(float r, float g, float b, float a);

	GLfloat _constantAttenuation;
	GLfloat _linearAttenuation;
	GLfloat _quadraticAttenuation;

	GLfloat _position[4];

	GLfloat _ambient[4];
	GLfloat _diffuse[4];
	GLfloat _specular[4];
};
#endif