#include "HSpotLight.h"
#include <cmath>

void HSpotLight::init() {
	initBase();

	glLightf(_light, GL_SPOT_CUTOFF, _cutoff);
	glLightf(_light, GL_SPOT_EXPONENT, _exponent);
}

void HSpotLight::setDirection(float x, float y, float z) {

	float l = sqrt(x*x + y*y + z*z);

	_direction[0] = x / l;
	_direction[1] = y / l;
	_direction[2] = z / l;

	//glLightfv(_light, GL_SPOT_DIRECTION, _direction);
}

void HSpotLight::setDirection(float alpha, float beta) {
	alpha = alpha * PI_F / 180.0f;
	beta = beta * PI_F / 180.0f;

	_direction[0] = sin(alpha) * cos(beta);
	_direction[1] = sin(-beta);
	_direction[2] = cos(alpha) * cos(beta);

	float l = sqrt(_direction[0]*_direction[0] + _direction[1]*_direction[1] + _direction[2]*_direction[2]);

	_direction[0] = _direction[0] / l;
	_direction[1] = _direction[1] / l;
	_direction[2] = _direction[2] / l;

	//glLightfv(_light, GL_SPOT_DIRECTION, _direction);
}

void HSpotLight::setDirection() {
	glLightfv(_light, GL_SPOT_DIRECTION, _direction);
}