uniform sampler2D modelTex;
uniform sampler2D blurTex;
uniform sampler2D modelDepth;
uniform sampler2D blurDepth;

varying vec2 vTexCoord;

void main(void)
{
   vec4 model = texture2D(modelTex, vTexCoord);
   vec4 blur = texture2D(blurTex, vTexCoord);
   float mDepth = texture2D(modelDepth, vTexCoord).a;
   float bDepth = texture2D(blurDepth, vTexCoord).a;
   
   vec4 col = mix(model, blur, (mDepth < bDepth)?1.0:0.0);
   
   gl_FragColor = col;
//   gl_FragColor = vec4(vec3(bDepth-0.98)*50.0,1.0);
}