#define LIGHTS 2
varying vec4 diffuse[LIGHTS], ambient[LIGHTS];
varying vec3 ecDir, halfVector[LIGHTS];
varying float dist[LIGHTS];
varying vec4 ambientGlobal;
varying vec3 normal;

varying vec3 reflection;

void main()
{
	vec4 ecPos = gl_ModelViewMatrix * gl_Vertex;
	ecDir = ecPos.xyz;

	normal = normalize(gl_NormalMatrix * gl_Normal);

	for (int i = 0; i < LIGHTS; i++) {
		dist[i] = length(gl_LightSource[i].position.xyz - ecDir);
	
		halfVector[i] = normalize(gl_LightSource[i].halfVector.xyz);

		diffuse[i] = gl_FrontMaterial.diffuse * gl_LightSource[i].diffuse;
		ambient[i] = gl_FrontMaterial.ambient * gl_LightSource[i].ambient;
	}
	
	ambientGlobal = gl_LightModel.ambient * gl_FrontMaterial.ambient;

	gl_TexCoord[0] = gl_MultiTexCoord0;
	gl_Position = ftransform();
	
	reflection = reflect(normalize(ecPos.xyz), normal);
}

