#ifndef HShadowMap_h
#define HShadowmap_h
 
#include "../platform.h"
#include "../HShader.h"
#include "../light/HLight.h"
 
using namespace std;
 
class HShadowMap {
public:
HShadowMap(int width, int height);
~HShadowMap();
 
// Depth Texture
void activateDepthTex();
void setupDepthTex();
void bindDepthTexture();
void bindDepthTexture(GLuint texUnit);
void unbindDepthTexture();
 
void setViewMatrix(
GLdouble eyeX, GLdouble eyeY, GLdouble eyeZ,
GLdouble centerX, GLdouble centerY, GLdouble centerZ,
GLdouble upX, GLdouble upY, GLdouble upZ
);
void loadViewMatrix();
void setLightProjectionMatrix(GLdouble fovy, GLdouble zNear, GLdouble zFar);
 
virtual void setTextureMatrixToLightSpaceTransform(GLuint matrix) = 0;
virtual void setLightViewMatrix() = 0;
virtual void beginRenderDepth() = 0;
virtual void endRenderDepth() = 0;
virtual void assignLight(HLight *light) = 0;
 
static const GLuint _TEXTURE_TYPE_DEPTH = GL_TEXTURE_2D;
static const GLuint _TEXTURE_UNIT_DEPTH = GL_TEXTURE2;
static GLint _textureSampler[MAX_SHADOWS];

GLuint _textureDepth, _frameBufferDepth;

protected:
int _texWidth, _texHeight;
 
GLfloat _viewMatrix[16];
GLfloat _lightViewMatrix[16];
GLfloat _lightProjectionMatrix[16];
 
GLfloat _viewDirection[3];
GLfloat _viewUpVector[3];
 
static HShader *_shaderDepth;
};
 
#endif