#ifndef HShadowMap_h
#define HShadowmap_h

#include "HShadowMap.h"
#include "../light/HSpotLight.h"

using namespace std;

class HShadowMapSpot : public HShadowMap {
public:
	HShadowMapSpot(int texWidth, int texHeight);
	~HShadowMapSpot();

	void setViewMatrix(
		GLdouble eyeX, GLdouble eyeY, GLdouble eyeZ,
		GLdouble centerX, GLdouble centerY, GLdouble centerZ,
		GLdouble upX, GLdouble upY, GLdouble upZ
	);

	void setLightViewMatrix();

	void setTextureMatrixToLightSpaceTransform(GLuint matrix);

	void loadViewMatrix();
	void assignLight(HLight *light);

	void beginRenderDepth();
	void endRenderDepth();

	void bindTextureToShader(string varName, HShader &shader);
	void bindTexture();
	void unbindTexture();

	float _upX, _upY, _upZ;
private:
	HSpotLight *_spotLight;
};

#endif